SystemOrganization addCategory: #GrammarProject!

SmaCCScanner subclass: #ListScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrammarProject'!

!ListScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
emptySymbolTokenId
	^ 11! !

!ListScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
errorTokenId
	^ 12! !

!ListScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
scanForToken
	self recordMatch: #(2).
	self step.
	(currentCharacter between: $0 and: $9)
		ifTrue: [ self recordMatch: #(3).
			self step.
			currentCharacter == $.
				ifTrue: [ self step.
					(currentCharacter between: $0 and: $9)
						ifTrue: [ [ self recordMatch: #(3).
							self step.
							currentCharacter between: $0 and: $9 ] whileTrue ] ].
			^ self reportLastMatch ].
	((currentCharacter between: $A and: $Z)
		or: [ currentCharacter between: $a and: $z ])
		ifTrue: [ [ self recordMatch: #(1).
			self step.
			currentCharacter == $'
				or: [ (currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z)
								or: [ currentCharacter == $_ or: [ currentCharacter between: $a and: $z ] ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter == Character cr
		or: [ currentCharacter == Character space
				or: [ currentCharacter = (Character value: 160) ] ])
		ifTrue: [ [ self recordMatch: #(2).
			self step.
			currentCharacter == Character cr
				or: [ currentCharacter == Character space
						or: [ currentCharacter = (Character value: 160) ] ] ] whileTrue ].
	^ self reportLastMatch! !

!ListScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
tokenActions
	^ #(nil #whitespace)! !

SmaCCScanner subclass: #ParagraphScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrammarProject'!

!ParagraphScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
emptySymbolTokenId
	^ 13! !

!ParagraphScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
errorTokenId
	^ 14! !

!ParagraphScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
scanForToken
	self recordMatch: #(4).
	self step.
	currentCharacter == $,
		ifTrue: [ self step.
			currentCharacter == Character space
				ifTrue: [ ^ self recordAndReportMatch: #(1) ].
			^ self reportLastMatch ].
	currentCharacter == $.
		ifTrue: [ ^ self recordAndReportMatch: #(2) ].
	(currentCharacter between: $A and: $Z)
		ifTrue: [ [ self recordMatch: #(3 5).
			self step.
			currentCharacter == $'
				or: [ (currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z)
								or: [ currentCharacter == $_ or: [ currentCharacter between: $a and: $z ] ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter between: $a and: $z)
		ifTrue: [ [ self recordMatch: #(5).
			self step.
			currentCharacter == $'
				or: [ (currentCharacter between: $0 and: $9)
						or: [ (currentCharacter between: $A and: $Z)
								or: [ currentCharacter == $_ or: [ currentCharacter between: $a and: $z ] ] ] ] ]
				whileTrue.
			^ self reportLastMatch ].
	(currentCharacter == Character cr
		or: [ currentCharacter == Character space
				or: [ currentCharacter = (Character value: 160) ] ])
		ifTrue: [ [ self recordMatch: #(4).
			self step.
			currentCharacter == Character cr
				or: [ currentCharacter == Character space
						or: [ currentCharacter = (Character value: 160) ] ] ] whileTrue ].
	^ self reportLastMatch! !

!ParagraphScanner methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
tokenActions
	^ #(nil nil nil #whitespace)! !

SmaCCParser subclass: #ListParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrammarProject'!

!ListParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/10/2018 22:38'!
cacheId
	^'2018-12-10T22:38:27.385544+01:00'! !

!ListParser class methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
definitionComment
"<name> :  [a-zA-Z]  ([a-zA-Z]  | [0-9] | _ | ')*;
<whitespace>:  (\x20|\xA0|\r)* ;
<double>:[0-9]((\.[0-9]+)?);
%root Root;
%prefix Entity_;
%annotate_tokens;
NameList
	: (Entite 'e' )+ {{list}}
	;
Entite
:( Name 'n1'   Pourcentage 'pourcent'  ){{entite}}
;
Name
	: <name>
	;
Pourcentage
	:<double>
	;"! !

!ListParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/10/2018 22:38'!
scannerClass
	^ListScanner! !

!ListParser class methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
startingStateForNameList
	^ 1! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionForEntite1: nodes
	| result |
	result := Entity_entite new.
	result n1: ((nodes at: 1) at: 1).
	result pourcent: ((nodes at: 1) at: 2).
	^ result! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionForName1: nodes
	^ nodes at: 1! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionForNameList1: nodes
	| result |
	result := Entity_list new.
	result addNodes: (nodes at: 1) to: result es.
	^ result! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionFor__Entite__e___1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^ result! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionFor__Entite__e___2: nodes
	| result |
	result := nodes at: 1.
	self add: (nodes at: 2) to: result.
	^ result! !

!ListParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceActionFor__Name__n1__Pourcentage__pourcent__1: nodes
	| result |
	result := Array new: 2.
	result at: 1 put: (nodes at: 1).
	result at: 2 put: (nodes at: 2).
	^ result! !

!ListParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
reduceTable
^#(
	#(6 1 #reduceActionForName1:) 
	#(4 1 #reduceActionForNameList1:) 
	#(13 1 #reduceActionForEntite1:) 
	#(5 1 #reduceActionFor__Entite__e___1:) 
	#(9 1 #reduceActionForName1:) 
	#(5 2 #reduceActionFor__Entite__e___2:) 
	#(7 1 #reduceActionForName1:) 
	#(8 2 #reduceActionFor__Name__n1__Pourcentage__pourcent__1:)
	).! !

!ListParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
symbolNames
	^ #('<name>' '<whitespace>' '<double>' 'NameList' '( Entite ''e'')+' 'Name' 'Pourcentage' '( Name ''n1'' Pourcentage ''pourcent'')' '( Entite ''e'')' 'B e g i n' 'E O F' 'error' 'Entite')! !

!ListParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
symbolTypes
	^ #(#SmaCCToken #SmaCCToken #SmaCCToken #Entity_list #OrderedCollection #SmaCCToken #SmaCCToken #OrderedCollection #Entity_entite #Entity_list #SmaCCToken #SmaCCToken #Entity_entite)! !

!ListParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:38'!
transitionTable
^#(
#[1 0 9 0 1 0 13 0 4 0 17 0 5 0 21 0 6 0 25 0 8 0 29 0 9 0 33 0 13] 
#[0 0 6 0 3] 
#[0 0 0 0 11] 
#[1 0 9 0 1 0 21 0 6 0 25 0 8 0 37 0 9 0 10 0 11 0 33 0 13] 
#[1 0 41 0 3 0 45 0 7] 
#[0 0 14 0 1 0 11] 
#[0 0 18 0 1 0 11] 
#[0 0 22 0 1 0 11] 
#[0 0 26 0 1 0 11] 
#[0 0 30 0 1 0 11] 
#[0 0 34 0 1 0 11]
	).! !

SmaCCGLRParser subclass: #ParagraphParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GrammarProject'!

!ParagraphParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/10/2018 22:39'!
cacheId
	^'2018-12-10T22:39:15.746544+01:00'! !

!ParagraphParser class methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
definitionComment
"<debut> :  [A-Z]  ([a-zA-Z]  | [0-9] | _ | ')*;
<whitespace>:  (\x20|\xA0|\r)* ;
<name> :  [a-zA-Z] ([a-zA-Z]  | [0-9] | _ | ')*;
%root Root;
%prefix Paragraphe_;
%annotate_tokens;
%glr;
Paragraph : Phrase 'phrases'+  {{paragraph}};
Phrase
	: Debut 'begin'   (Nom 'mt'  | "", "" |Debut 'begin')*  "".""  {{phrase}}
	;
	Debut
	:<debut>
	;

Nom
	:<name>
	;"! !

!ParagraphParser class methodsFor: 'generated-accessing' stamp: 'AllezSchema 12/10/2018 22:39'!
scannerClass
	^ParagraphScanner! !

!ParagraphParser class methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
startingStateForParagraph
	^ 1! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionForDebut1: nodes
	^ nodes at: 1! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionForParagraph1: nodes
	| result |
	result := Paragraphe_paragraph new.
	result addNodes: (nodes at: 1) to: result phraseses.
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionForPhrase1: nodes
	| result |
	result := Paragraphe_phrase new.
	result addToken: (nodes at: 1) to: result begins.
	result addTokens: ((nodes at: 2) at: 1) to: result mts.
	result addTokens: ((nodes at: 2) at: 2) to: result comma_Tokens.
	result addTokens: ((nodes at: 2) at: 3) to: result begins.
	result periodToken: (nodes at: 3).
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionForPhrase_1: nodes
	| result |
	result := OrderedCollection new: 2.
	self add: (nodes at: 1) to: result.
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionForPhrase_2: nodes
	| result |
	result := nodes at: 1.
	self add: (nodes at: 2) to: result.
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionFor__Nom__mt_______Debut__begin__1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (nodes at: 1).
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionFor__Nom__mt_______Debut__begin__2: nodes
	| result |
	result := Array new: 3.
	result at: 2 put: (nodes at: 1).
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionFor__Nom__mt_______Debut__begin__3: nodes
	| result |
	result := Array new: 3.
	result at: 3 put: (nodes at: 1).
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionFor__Nom__mt_______Debut__begin___1: nodes
	| result |
	result := Array new: 3.
	result at: 1 put: (OrderedCollection new: 2).
	result at: 2 put: (OrderedCollection new: 2).
	result at: 3 put: (OrderedCollection new: 2).
	^ result! !

!ParagraphParser methodsFor: 'generated-reduction actions' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceActionFor__Nom__mt_______Debut__begin___2: nodes
	| result |
	result := nodes at: 1.
	self add: ((nodes at: 2) at: 1) to: (result at: 1).
	self add: ((nodes at: 2) at: 2) to: (result at: 2).
	self add: ((nodes at: 2) at: 3) to: (result at: 3).
	^ result! !

!ParagraphParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
reduceTable
^#(
	#(7 1 #reduceActionForDebut1:) 
	#(10 0 #reduceActionFor__Nom__mt_______Debut__begin___1:) 
	#(12 1 #reduceActionForParagraph1:) 
	#(8 1 #reduceActionForPhrase_1:) 
	#(8 2 #reduceActionForPhrase_2:) 
	#(9 1 #reduceActionFor__Nom__mt_______Debut__begin__2:) 
	#(11 3 #reduceActionForPhrase1:) 
	#(15 1 #reduceActionForDebut1:) 
	#(9 1 #reduceActionFor__Nom__mt_______Debut__begin__3:) 
	#(10 2 #reduceActionFor__Nom__mt_______Debut__begin___2:) 
	#(9 1 #reduceActionFor__Nom__mt_______Debut__begin__1:)
	).! !

!ParagraphParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
symbolNames
	^ #('", "' '"."' '<debut>' '<whitespace>' '<name>' 'B e g i n' 'Debut' 'Phrase+' '( Nom ''mt'' ", " Debut ''begin'')' '( Nom ''mt'' ", " Debut ''begin'')*' 'Phrase' 'Paragraph' 'E O F' 'error' 'Nom')! !

!ParagraphParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
symbolTypes
	^ #(#SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #SmaCCToken #Paragraphe_paragraph #SmaCCToken #OrderedCollection #OrderedCollection #OrderedCollection #Paragraphe_phrase #Paragraphe_paragraph #SmaCCToken #SmaCCToken #SmaCCToken)! !

!ParagraphParser methodsFor: 'generated' stamp: 'AllezSchema 12/10/2018 22:39'!
transitionTable
^#(
#[1 0 9 0 3 0 13 0 7 0 17 0 8 0 21 0 11 0 25 0 12] 
#[0 0 6 0 1 0 2 0 3 0 5] 
#[1 0 10 0 1 0 10 0 2 0 10 0 3 0 10 0 5 0 29 0 10] 
#[1 0 9 0 3 0 13 0 7 0 33 0 11 0 14 0 13] 
#[0 0 18 0 3 0 13] 
#[0 0 0 0 13] 
#[1 0 37 0 1 0 41 0 2 0 9 0 3 0 45 0 5 0 49 0 7 0 53 0 9 0 57 0 15] 
#[0 0 22 0 3 0 13] 
#[0 0 26 0 1 0 2 0 3 0 5] 
#[0 0 30 0 3 0 13] 
#[0 0 34 0 1 0 2 0 3 0 5] 
#[0 0 38 0 1 0 2 0 3 0 5] 
#[0 0 42 0 1 0 2 0 3 0 5] 
#[0 0 46 0 1 0 2 0 3 0 5]
	).! !
